#!/usr/bin/python
# -*- coding: utf8 -*-
# projet pour génération automatique de scores

import wx
import os
import score

class fen(wx.Frame):
	def __init__(self, titre):
		self. d_part = {}
		self.l_score = []		# liste de d_score crées dans la fenetre score
		self.rep = "" 			# répertoire de travail
		wx.Frame.__init__(self, None, wx.ID_ANY, title = titre , pos = (200,200) )		# création de la fenetre de premier niveau
		self.grille = wx.GridBagSizer()		# création de la grille type tableur : accès direct aux cellules
		self.t_fic = wx.TextCtrl(self, wx.ID_ANY, 'lily.ly' )		# champ de saisie, size=(150, 30)
		e_fic = wx.StaticText(self, wx.ID_ANY, "fichier à générer" )	# etiquette associée
		self.t_version = wx.TextCtrl(self, wx.ID_ANY, "2.8.6")
		e_version = wx.StaticText(self, wx.ID_ANY, "version : " )
		self.t_part = wx.TextCtrl(self, wx.ID_ANY, 'Titre')		# champ de saisie, size=(150, 30) 
		e_part = wx.StaticText(self, wx.ID_ANY, "Titre partition" )	# etiquette associée
		self.t_inclusion = wx.TextCtrl(self, wx.ID_ANY, "italiano.ly\n", style = wx.TE_MULTILINE)
		e_inclusion = wx.StaticText(self, wx.ID_ANY, "Inclusions : " )

		b_ok = wx.Button(self, wx.ID_ANY , "OK")
		b_score = wx.Button(self, wx.ID_ANY , "Ajout Score")
		b_fermer = wx.Button(self, wx.ID_ANY , "Fermer")
		b_rep = wx.Button(self, wx.ID_ANY , "Naviguer")
		self.Bind( wx.EVT_BUTTON, self.b_ok_clic, b_ok)
		self.Bind( wx.EVT_BUTTON, self.b_score_clic, b_score)
		self.Bind( wx.EVT_BUTTON, self.b_fermer_clic, b_fermer)
		self.Bind( wx.EVT_BUTTON, self.b_rep_clic, b_rep )
		x = 0
		self.grille.Add (self.t_fic, (x,1) , (1,1) , wx.EXPAND )	# ajout des champs  : objet, où (L, C), extension (nb L, nb C), formatage
		self.grille.Add(e_fic, (x,0), (1,1), wx.EXPAND )
		self.grille.Add(b_rep, (x,2) , ( 1,1 ) , wx.EXPAND )		# dialogue de changement de répertoire
		x +=1
		self.grille.Add(e_version, (x,0), (1,1), wx.EXPAND )
		self.grille.Add(self.t_version, (x,1), (1,1), wx.EXPAND )
		x+=1
		self.grille.Add(e_part, (x,0), (1,1), wx.EXPAND )
		self.grille.Add(self.t_part, (x,1), (1,1), wx.EXPAND )
		x +=1
		self.grille.Add ( e_inclusion, (x,0) , (1,1) , wx.EXPAND )
		self.grille.Add(self.t_inclusion, (x,1), (1,1), wx.EXPAND )
		x +=2
		self.grille.Add(b_score, (x, 0), (1, 1))
		self.grille.Add(b_fermer, (x, 1), (1, 1))
		self.grille.Add(b_ok, (x, 2), (1, 1))
#		self.grille.AddGrowableCol(0)		# redimension des champs possible
		self.grille.AddGrowableCol(1)		
#		self.grille.AddGrowableCol(2)
#		self.SetSizeHints(-1,self.GetSize().y,-1,2*(self.GetSize().y) );	# blocage en Y à sa taille actuelle, en X -1 => illimité
#																									# min X, min Y, max X, max Y
		self.SetSizerAndFit(self.grille)		# mise en place finale
		self.Show(True)					# et affichage
		
	def b_rep_clic (self, ev_b_rep):
		fen_rep = wx.DirDialog(self, "Répertoire", style=wx.DD_DEFAULT_STYLE | wx.DD_NEW_DIR_BUTTON)
		if fen_rep.ShowModal() == wx.ID_OK:
			self.SetStatusText( fen_rep.GetPath() )
			self.rep = fen_rep.GetPath()
			self.t_fic.SetValue( self.rep +"/lily.ly")
			self.SetSizerAndFit(self.grille)		# redimensionne la fenetre
		fen_rep.Destroy()
		
	def fichier (self, ev_fic):
		fen_fic = wx.FileDialog(self, "Fichier :", os.getcwd(), "", "*.*", wx.OPEN)
		if fen_fic.ShowModal() == wx.ID_OK:
			chemin = fen_fic.GetPath()
			chemin_base = os.path.basename( chemin )
			self.SetStatusText("chemin courant : %s" % chemin_base )
		fen_fic.Destroy()
		
	def b_ok_clic(self, ev_b_ok):		# fin de l'acquisition des données
		self.d_part ['fic']= self.t_fic.GetValue()
		self.d_part ['part'] = self.t_part.GetValue()
		self.d_part ['version'] = self.t_version.GetValue()
		self.d_part ['liste_ds'] = self.l_score
##########################################################
##
##  		Création du fichier
##
##########################################################

		fic_sort = open ( self.d_part ['fic'], 'w')
#		fic_sort.write ('%  Essai de génération automatique \n')
		fic_sort.write('\\version "'+ self.d_part['version'] +'"\n' )
		fic_sort.write('\\header { title = "' +   self.d_part ['part'] + '" }\n\n')
		fic_sort.write ( '% Inclusions \n' )
		for n_inclus in range ( self.t_inclusion.GetNumberOfLines() ) :
			if ( self.t_inclusion.GetLineLength (n_inclus ) > 0 ) :
				fic_sort.write ( '\include "%s"\n' % self.t_inclusion.GetLineText( n_inclus) )
		liste =  self.d_part['liste_ds']
		
		for n_score in range ( len ( liste ) ) : # balayage des blocs scores disponibles et écriture dans le fichier
			dico_score = liste[ n_score ]
			nom_score = dico_score['nom']		# dans bloc header
			tempo_score = dico_score['tempo']
			type_score = dico_score['type']
			armature_score = dico_score['armature']
			vitesse_score = dico_score['vitesse']
			liste_dp_score = dico_score['liste_dp']
			fic_sort.write('\score {\n \t\context %s \n' % type_score )
			fic_sort.write('\t<<\n')

			for  n_port in range ( len( liste_dp_score )  ) :#création des blocs Staff
				dico_portee = liste_dp_score[ n_port ]
				clef = dico_portee ['clef']
				instrument = dico_portee ['instrument']
				instr = dico_portee ['instr']
				instr_midi =  dico_portee ['instr_midi']
				nom_port = dico_portee ['portee']
				liste_dv_portee = dico_portee ['liste_dv']
				if ( len ( str ( nom_port ) ) > 0 ) :
					nom_port = " = " + nom_port
				fic_sort.write('\t\t\context Staff %s \n\t\t<<\n'  % ( nom_port ) ) 
				fic_sort.write ('\t\t\t\set Staff.instrument = \markup { \column { %s } }\n' % instrument )
				fic_sort.write('\t\t\t\set Staff.midiInstrument = "%s"\n' % instr_midi )
				fic_sort.write('\t\t\t\clef %s \n' % clef )
				fic_sort.write('\t\t\t\key %s \major\n' % armature_score )
				fic_sort.write('\t\t\t\\time %s\n'% tempo_score )
				
				for n_voix in range ( len ( liste_dv_portee ) ) :		# ajout des voix à la portée
					dico_voix = liste_dv_portee [ n_voix ]
					nom_notes = dico_voix ['notes' ]
					nom_paroles = dico_voix ['paroles' ]
					ton_transpose = dico_voix['transpose']
					nom_voix = dico_voix ['voix' ]
					fic_sort.write ( '\t\t\t\context Voice = %s { \%s }\n' % (nom_voix, nom_notes ) )
					if ( ton_transpose != "" ) :		# au niveau de la defifnition des notes ?
						fic_sort.write ( '\t\t\t\\transpose do %s \n' % (ton_transpose )  )
					if ( nom_paroles != "") :
						fic_sort.write ( '\t\t\t\lyricsto "%s" \context Lyrics \%s \n' % (nom_voix, nom_paroles ) )
			fic_sort.write ( '\t\t>>\n' ) 	# fin d'un bloc Staff
		fic_sort.write ( '\t>>\n' ) 	# fin d'un bloc type
		if ( vitesse_score != "" ) :
			fic_sort.write ('\t\midi { \t\t\\tempo %s \n\t}\n' % vitesse_score )
			fic_sort.write ('\t\layout { }\n' )
			
		fic_sort.write ('\t\header { piece = "%s" }\n'  % nom_score ) 
		fic_sort.write ( "}\n" ) 	# fin d'un bloc score ajouter au dessus les blocs header
#self.d_score['liste_dp']['type']
		fic_sort.close()
#		return self.d_part		# retourne à qui ?
		
	def b_score_clic(self, ev_b_score):		# acquisistion d'un nouveau bloc score
		self.fenetre_score = score.fen_score("Score")
		self.l_score.append ( self.fenetre_score.lit_part() )
		return True
		
	def b_fermer_clic ( self, ev_b_fermer):
		self.Destroy()

class fen_principale(wx.App):
	def OnInit(self):
		self.fenetre = fen('essai.py')
		self.fenetre.Show(True)
		self.SetTopWindow(self.fenetre)
		return True
	
if __name__ == "__main__" :
	d_score = {}
	appli = fen_principale()
	appli.MainLoop()
#fic_sor = 
